﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using EtherFax.Client;
using Newtonsoft.Json;
using System.Configuration;
using System.IO;
using System.Security.Cryptography;
using Microsoft.Extensions.Logging;


namespace NewClientTest
{
    class Program
    {
        //public static string svcuser = Variables.ServiceUser;
        //public static string svcpass = Variables.ServicePass;
        public static string svcApiKey = Variables.ServiceAPIKey;
        public static string inboxfolder = Variables.InboxFolder;
        static void Main(string[] args)
        {

            var loggerFactory = LoggerFactory.Create(builder => {
                builder.AddConsole(options =>{});
                builder.SetMinimumLevel(LogLevel.Trace);
            });

            var logger = loggerFactory.CreateLogger<EtherFaxClient>();


            Console.WriteLine("EtherFAX Push Listener - Ctrl+C to quit");
            //Console.WriteLine("Account: " + svcuser);
            Console.WriteLine("Inbox Folder: " + inboxfolder);
            Console.WriteLine();
            //var client = new EtherFaxClient(svcuser, svcpass);

            var client = new EtherFaxClient();
            client.ServiceAddress = "https://connect.etherfax.net/rest/3.0/api";
            client.SetCredentials(svcApiKey);
            client.Logger = logger;


            Console.WriteLine("Trying to fetch account...");
            try
            {
                var account = client.GetFaxAccount();
                if (account == null)
                {
                    Console.WriteLine("Failed to get account. Check credentials or connection.");
                }
                else
                {
                    Console.WriteLine("Got account:" + JsonConvert.SerializeObject(account) + "\n");
                }
            }
            catch
            {
                Console.WriteLine("Failed to get account. Check credentials or connection.");
            }

            FaxEvents pushevent = new FaxEvents();

            try
            {
                client.FaxStatusEvent += pushevent.OnFaxStatusEvent;
                client.FaxReceiveEvent += pushevent.OnFaxReceiveEvent;
                client.StartPushListener();
                Console.WriteLine("Push channel opened for send and receive");
            }

            catch
            {
                throw;
                //Console.WriteLine("Failed to open push channel");
            }

            while (true)
            {
                Thread.Sleep(8000);

            }
        }

    }

    class FaxEvents
    {
        public void OnFaxReceiveEvent(object sender, FaxReceiveEventArgs e)
        {
            var client = sender as EtherFaxClient;

            Console.WriteLine("PUSH INBOUND: " + JsonConvert.SerializeObject(e.Receive) + "\n");

            /*
            var filename = e.Receive.JobId + ".tif";
            var filepath = Variables.InboxFolder + "\\" + filename;
            var image = client.GetFax(e.Receive.JobId).FaxImage;
            try
            {
                using (BinaryWriter writer = new BinaryWriter(File.Open(filepath, FileMode.Create)))
                {
                    writer.Write(image);
                    writer.Write(true);
                }
                client.SetFaxReceived(e.Receive.JobId);
                Console.WriteLine("FILE: Image saved to " + filepath);
            }
            catch (Exception)
            {
                throw;
            }
            */

        }

        public void OnFaxStatusEvent(object sender, FaxStatusEventArgs e)
        {
            Console.WriteLine("PUSH OUTBOUND: " + JsonConvert.SerializeObject(e.Status) + "\n");

            if (e.Status.FaxResult != FaxResult.InProgress)
            {
            }
        }
    }

    public class Variables
    {
        public static string Hostname = Environment.MachineName;
        public static string ServiceUser = "";
        public static string ServicePass = "";
        public static string ServiceAPIKey = "YOURAPIKEYHERE";
        public static string InboxFolder = "/tmp";

    }
}

